clear all
close all

% ESERCIZIO 2 del 7 luglio 2017

f=@(x) exp(sin(x));

xe=linspace(-pi,pi,100);
fe=f(xe);

% punto (a)
k=1;
for n=5:2:15,
 
x=-pi*cos([0:n]*pi/n);
y=f(x);
d=DiffDivise(x,y);
pe=Horner(d,x,xe);
err(k)=norm(fe-pe)/norm(fe);
k=k+1;
end

plot(xe,fe,'r',xe,pe,'b',x,y,'ok');
legend('funzione','polinomio', 'punti interp')

figure(2)
semilogy(1:length(err),err)

% punto (b)
k=1;
for n=5:2:15
x=-pi*cos([0:n]*pi/n);
y=f(x);

se=spline(x,y,xe);  %spline cubica nei punti di valutazione
err_s(k)=norm(fe-se)/norm(fe);
k=k+1;
end

figure(3)
plot(xe,fe,'r-',xe,se,'b--');
legend('funzione','spline')
figure(4)
semilogy(1:length(err_s),err_s)

k=1;
for n=5:2:15
% punti equispaziati
x=linspace(-pi,pi, n+1);
y=f(x);

se=spline(x,y,xe);  %spline cubica nei punti di valutazione
err_se(k)=norm(fe-se)/norm(fe);
k=k+1;
end


errors=table(err',  err_s', err_se')
% si nota che usando la spline su nodi 
% equispaziati gli errori sono dello stesso
% ordine, mentre se la spline viene usata su
% punti di Chevsyhev-Lobatto l'errore con 
% e' di un ordine superiore soprattutto
% per n=11,13,15